image: docker:latest
services:
- docker:dind

stages:
- test
- build
- release

variables:
  DOCKER_REGISTRY:      'index.docker.io'
  CONTAINER_IMAGE:      "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME"
  TEST_IMAGE:           "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME:$CI_COMMIT_SHORT_SHA"
  HEAD_IMAGE:           "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME:head"
  RELEASE_IMAGE:        "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME:latest"
  GITTAG_IMAGE:         "$DOCKER_REGISTRY/$DOCKER_HUB_REPOSITORY/$CI_PROJECT_NAME:$CI_COMMIT_REF_NAME"


Dockerfile lint:
  stage: test
  image: hadolint/hadolint:latest-debian
  script:
    - hadolint Dockerfile
  only:
    changes:
      - Dockerfile
  allow_failure: true

markdown lint:
  stage: test
  image: pipelinecomponents/markdownlint:latest
  script:
    - mdl --style all --warnings .
  only:
    changes:
      - "**/*.md"

bash lint:
    stage: test
    image: koalaman/shellcheck-alpine:stable
    before_script:
        - shellcheck --version
    script:
        - find . -type f -iname '*.*sh' -exec shellcheck --exclude=SC1091 '{}' +
    only:
        changes:
            - "**/*.*sh"

build:
  stage: build
  before_script:
    - docker login --username "$DOCKER_HUB_LOGIN" --password "$DOCKER_REGISTRY_PASSWORD"
  script:
    - docker pull $HEAD_IMAGE || true
    - docker build --cache-from $HEAD_IMAGE --tag $TEST_IMAGE .
    - docker tag $TEST_IMAGE $HEAD_IMAGE
    - docker push $HEAD_IMAGE
    - docker push $TEST_IMAGE

release:
  stage: release
  variables:
    GIT_STRATEGY: none
  before_script:
    - docker login --username "$DOCKER_HUB_LOGIN" --password "$DOCKER_REGISTRY_PASSWORD"
  script:
    - docker pull $TEST_IMAGE
    - docker tag $TEST_IMAGE $RELEASE_IMAGE
    - docker push $RELEASE_IMAGE
  only:
    - master

gittag:
  stage: release
  variables:
    GIT_STRATEGY: none
  before_script:
    - docker login --username "$DOCKER_HUB_LOGIN" --password "$DOCKER_REGISTRY_PASSWORD"
  script:
    - docker pull $TEST_IMAGE
    - docker tag $TEST_IMAGE $GITTAG_IMAGE
    - docker push $GITTAG_IMAGE
  only:
    - tags


